//Mery特許事務ツール.js  ver. 1.20  2022/11/26

var Kakko="　【】";//【０００１】等の段落番号のかっこ前に入れるスペースを指定
var ClRenum=1; //クレームリナンバーする(1)、しない(0)
var MRtxt="MULTIREP.txt";//一括置換用辞書データtxtの名前
var PRtxt="para_base.txt";//平行置換用辞書データtxtの名前
//var Narabe=1;//一括置換用辞書ファイル並べ替えする(1)、しない(0)
var separator=",";//一括置換用ファイル/平行置換用ファイルのセパレータ
var	startTime;
var	endTime;
var filename;
var fso = new ActiveXObject("Scripting.FileSystemObject");
var objWsh = new ActiveXObject("WScript.Shell");
var mytxt = objWsh.SpecialFolders("MyDocuments");
var docB;
var Com;

var k=Rini();//MeryTG.iniの内容を読み込んで、変数指定
if (k!=-1){
	var K1=k.split('=');
	for (i = 0; i < K1.length; i++) {
		if (K1[i]=="Kakko"){
			Kakko=K1[i+1];
		} else if (K1[i]=="ClRenum"){
			ClRenum=K1[i+1];
		} else if (K1[i]=="MRtxt"){
			MRtxt=K1[i+1];
		} else if (K1[i]=="PRtxt"){
			PRtxt=K1[i+1];
		} else if (K1[i]=="Narabe"){
			Narabe=K1[i+1];
		} else if (K1[i]=="separator"){
			separator=K1[i+1];
		}
	}
}

var t;

var menu = {};
menu["段落番号付け(&A)"] = 1;//【】付きの段落番号を付ける
menu["段落番号取り(&B)"] = 2;//【】付きの段落番号を削除
menu["符号表の作成(&C)"] = 3;//fugohyo.txtとして符号表を作成  ゴミデータ行はチェックして削除のこと
menu["要約書の文字数を数える(&D)"] = 4;//全角が1、半角が0.5 選択されている場合は、選択範囲の文字数
menu["Word文書へ変換(&E)"] = 5;//原文書をWORD文書に。上付き、下付き、ｱﾝﾀﾞｰﾗｲﾝなど変換。
menu["符号欄利用ﾏｰｷﾝｸﾞ(&F)"] = 6;//符号欄にカーソルを当てて、それに基づきマーキング。予め範囲指定してあれば、それを検索・マーキング。
menu["上付など(&1)"] = {};
menu["上付など(&1)"]["上付(&G)"] = 7;
menu["上付など(&1)"]["下付(&H)"] = 8;
menu["上付など(&1)"]["下線(&I)"] = 9;
menu["上付など(&1)"]["倍角(&J)"] = 10;
menu["----"] = 0;
menu["一括置換(&K)"] = 11;
menu["Utility(&2)"] = {};
menu["Utility(&2)"]["----"] = 0;
menu["Utility(&2)"][MRtxt+"を開く(&L)"] = 12;
//menu["Utility(&2)"]["一括置換用辞書データを第一要素の長い順に並べる(&M)"] = 13;
menu["Utility(&2)"]["buhinmei.txtを開く(&N)"] = 13;
menu["Utility(&2)"]["特許出願全体HTMLを読み込む(&O)"] = 14;
menu["Utility(&2)"]["特許明細書txtを読み込む(&P)"] = 15;
menu["Utility(&2)"]["実用明細書txtを読み込む(&Q)"] = 16;
menu["Utility(&2)"]["PCTRO明細書txtを読み込む(&R)"] = 17;
menu["Utility(&2)"]["MeryTG.iniを開く(&S)"] = 18;
menu["Utility(&2)"][PRtxt+"を開く(&T)"] = 19;
menu["平行置換(&U)"] = 20;

var nRet = ShowPopupMenu(menu, mePosMouse);
switch (nRet) {
	case 1:
		Danzuke();
		break;
	case 2:
		Dantori();
		break;
	case 3:
		Fugo();
		break;
	case 4:
		Yoyaku();
		break;
	case 5:
		Word();
		break;
	case 6:
		Fmark();
		break;
	case 7:
		Tag("SUP");
		break;
	case 8:
		Tag("SUB");
		break;
	case 9:
		Tag("U");
		break;
	case 10:
		Tag("FONT");
		break;
	case 11:
		MLTREP();
		break;
	case 12:
		docB = OpenFile( mytxt+"\\"+MRtxt, 0, 1 );
		break;
	case 13:
		docB = OpenFile( mytxt+"\\buhinmei.txt", 0, 1 );
		break;
	case 14:
		var txt=TextRead("TG出願.txt");
		if (txt!=-1){
			document.write(txt);
			document.selection.StartOfDocument( false );//文頭へ
		} else {
			alert("読み込む文書が見当たりません");
		}
		break;
	case 15:
		txt=TextRead("TG特許明細書.txt");
		if (txt!=-1){
			document.write(txt);
			document.selection.StartOfDocument( false );//文頭へ
		} else {
			alert("読み込む文書が見当たりません");
		}
		break;
	case 16:
		txt=TextRead("TG実用明細書.txt");
		if (txt!=-1){
			document.write(txt);
			document.selection.StartOfDocument( false );//文頭へ
		} else {
			alert("読み込む文書が見当たりません");
		}
		break;
	case 17:
		txt=TextRead("TGPCTRO明細書.txt");
		if (txt!=-1){
			document.write(txt);
			document.selection.StartOfDocument( false );//文頭へ
		} else {
			alert("読み込む文書が見当たりません");
		}
		break;
	case 18:
		docB = OpenFile( mytxt+"\\MeryTG.ini", 0, 1 );
		break;
	case 19:
		docB = OpenFile( mytxt+"\\"+PRtxt, 0, 1 );
		break;
	case 20:
		Parachikan();
		break;
	default:
		break;
}

function Danzuke(){
	var b = document.selection.Find("<BR>", meFindAround);
	var Kaigyo="";
	if (b){//<BR>ありなら
		Kaigyo = "<BR>";
	}
	Kaigyo= Kaigyo + "\n";
	var a = document.selection.Find("【[０-９0-9]*】",meFindReplaceRegExp | meFindAround);
	if (a){//既に段落番号ありなら、リナンバリング
		document.selection.Replace( "【[０-９0-9]*】", "【】", meFindReplaceRegExp | meReplaceAll);
		document.selection.StartOfDocument( false );//文頭へ
		if (ClRenum == 1)  SeikyuRenum();
		var K=DantsukeMain();
	} else {
		document.selection.StartOfDocument( false );//文頭へ
		a = document.selection.Find( "【技術分野】", meFindNext);
		if (!a) //【技術分野】がなければ、その旨を告げてマクロを終了
		{
			alert("【技術分野】がないので、マクロを終了します");
			Quit();
		} else 	{
			var fY = document.selection.GetActivePointY(mePosLogical);//  fYは"【技術分野】"の行
			var a =document.selection.Find("【符号の説明】",meFindNext);
			if (!a){//【符号の説明】欄がなければ、次の【書類名】の欄チェック
				a =document.selection.Find("【書類名】",meFindNext);
				if (!a){//次の【書類名】の欄がなければ最終行へカーソル移動
					document.selection.EndOfDocument( false );
				}
			}
			with (document.selection){
				SetAnchorPoint(mePosLogical, 1, fY);//選択開始行にfYを指定
				Replace( "\n", "\n"+Kakko, meFindReplaceRegExp | meReplaceSelOnly | meReplaceAll);
				Replace( Kakko+"【", "【", meReplaceAll);
				a = Find("【図面の簡単な説明】",meFindNext | meFindAround);
				if (a){//【図面の簡単な説明】の欄があれば
					fY = GetActivePointY(mePosLogical);//  fYは"【図面の簡単な説明】"の行
					a = Find("実施するための形態】",meFindNext);//実施するための形態】の欄を探す
					if (a){
						SetAnchorPoint(mePosLogical, 1, fY);//選択開始行にfYを指定
						Replace( "\n"+Kakko, "\n", meFindReplaceRegExp | meReplaceSelOnly | meReplaceAll);
					}
				}
				Replace( "【図面の簡単な説明】"+Kaigyo, "【図面の簡単な説明】"+Kaigyo+Kakko, meFindReplaceRegExp);
				Replace( "【符号の説明】"+Kaigyo, "【符号の説明】"+Kaigyo+Kakko, meFindReplaceRegExp);
				Replace( "【受託番号】"+Kaigyo, "【受託番号】"+Kaigyo+Kakko, meFindReplaceRegExp);
				Replace( "【】", "【】"+Kaigyo, meFindReplaceRegExp | meReplaceAll);
				StartOfDocument( false );//文頭へ
			}
			if (ClRenum == 1)  SeikyuRenum();
			K=DantsukeMain();
		}
	}
	Status=String(K)+"段処理しました";
}

function SeikyuRenum(){
	document.selection.Replace( "【請求項[０-９0-9]*】", "【請求項】", meFindReplaceRegExp | meReplaceAll);
	document.selection.EndOfDocument(false);
	var E=document.GetLines();
	document.selection.StartOfDocument(false);
	for (i = 1; i < E; i++) {
		var a = document.selection.Find( "【請求項】", meFindNext );
		if (!a){
			i = i - 1;
			break;
		} 
		document.selection.collapse(meCollapseStart);
		document.selection.CharLeft(false,1);
		var moji=String(i);
		moji= moji.replace(/[0-9]/g, function(s) {//半角→全角
		return String.fromCharCode(s.charCodeAt(0) + 0xFEE0);
			});
   		document.write(moji);
	}
}

function DantsukeMain(){
	with (document.selection){
		EndOfDocument(false);
		var E=document.GetLines();
		StartOfDocument(false);
		for (i = 1; i < E; i++) {
			var a = Find( "【】", meFindNext );
			if (!a){
				i = i - 1;
				break;
			} 
			collapse(meCollapseStart);
			CharLeft(false,1);
			var moji=String(i);
			moji= moji.replace(/[0-9]/g, function(s) {//半角→全角
			return String.fromCharCode(s.charCodeAt(0) + 0xFEE0);
				});
			var n = moji.length;
			switch (n) {
				case 1:
					moji="０００" + moji;
					break;
				case 2:
  					moji="００" + moji;
  					break;
				case 3:
  					moji="０" + moji;
  					break;
				case 4:
				default:
  					break;
				}
  			document.write(moji);
  		}
	}
	return i;
}

function Dantori(){
	with (document.selection){
		EndOfDocument( false );
		E=document.GetLines();
		for (i = 1; i < E; i++) {
			a = Find("【[０-９0-9]*】", meFindPrevious | meFindReplaceRegExp);
			if (a){
				SelectLine();
				Delete(1);
			} else {
				break;
			}
		}
	}
	i = i - 1;
	Status= String(i)+"個削除しました";
}

function Fugo(){
	startTime = new Date();
	filename = document.FullName;
	var pos = filename.indexOf("."); 
	var filebase;
	if (pos == -1){//ファイル名の基幹部を得る
  		filebase=filename;
	} else {
		filebase= filename.substr(0, pos);
	}
	document.save( filebase + "_fugohyo.txt" );
	var t = TextRead('buhinmei.txt');
	if(t!=-1){
		var s1=t.split("\n");
		for (i = 0; i < s1.length; i++) {
			var D = s1[i];
			if ((i == s1.length-1) && (D.indexOf("\n") == -1)){//buhinmei.txt最終行がデータ＋EOFの場合
				D = D;
			} else {
				D = D.substr(0, D.length - 1);
			}
			var T = D.slice(0,1);//一文字目
			if (!((T=="/")||(D==""))){
//				alert('行 '+i+' '+D+D.length);
				document.selection.Replace( D,Num2Kan(i), meReplaceAll);
				Status="";
			}
		}
	}
	with (document.selection){
		EndOfDocument();
		document.write('\n');//FOFの前が改行でないと困るから
		a = Find( "【技術分野】", meFindNext|meFindAround);
		if (a){ //【技術分野】があれば、文頭からそこまでを削除
			StartOfDocument( true );//文頭へ
			Delete();
		}
			//符号表でのゴミデータを減らす工夫↓
		Replace( "[前上下後]記" , "まえうえき", meFindReplaceRegExp | meReplaceAll);
		Replace( "図中" , "ずちゅう", meReplaceAll);
		Replace( "[該各図]" , "がいかくず", meFindReplaceRegExp | meReplaceAll);
		Replace( "文献" , "ぶんけん", meReplaceAll);
		Replace( "対し" , "たいし", meReplaceAll);
		Replace( "如き" , "ごとき", meReplaceAll);
		Replace( "請求項" , "せいきゅうこう", meReplaceAll);
		Replace( "特許第" , "とっきょだい", meReplaceAll);
		Replace( "特許" , "とっきょ", meReplaceAll);
		Replace( "出願第" , "しゅつがんだい", meReplaceAll);
		Replace( "出願" , "しゅつがん", meReplaceAll);
		Replace( "実施例" , "じっしれい", meReplaceAll);
		Replace( "乃至" , "ないし", meReplaceAll);
			//ここまで↑
			//頭に印◆◆◆をつけて、符号行を符号+"  "+物の名に入れ替え
		var list = "([\\p{Han}\\p{Katakana}ー・]+[きちひみりして][\\p{Han}\\p{Katakana}ー・]+[きちひみりして][\\p{Han}\\p{Katakana}ー・（()）]+)([０-９0-9A-ZＡ-Ｚa-zａ-ｚΑ-Я.．,，’”'\"]+)";//切り欠き部４ 等の符号
		Replace(list, "\\n◆◆◆$2  $1\\n", meFindReplaceRegExp | meReplaceAll);
		list = "([\\p{Han}\\p{Katakana}ー・]+[きちひみりして][\\p{Han}\\p{Katakana}ー・（()）]+)([０-９0-9A-ZＡ-Ｚa-zａ-ｚΑ-Я.．,，’”'\"]+)";//切欠き部４ 等の符号
		Replace(list, "\\n◆◆◆$2  $1\\n", meFindReplaceRegExp | meReplaceAll);
		list="([\\p{Han}\\p{Katakana}ー・（()）]+)([０-９0-9A-ZＡ-Ｚa-zａ-ｚΑ-Я.．,，’”'\"]+)";//切欠部４ 等の符号
		Replace(list, "\\n◆◆◆$2  $1\\n", meFindReplaceRegExp | meReplaceAll);
		Replace("^[^◆]+$\n", "", meFindReplaceRegExp | meReplaceAll);//不要行削除
		Replace("◆◆◆", "", meReplaceAll);//頭の印◆◆◆を取る
			//符号表が数値順で並ぶよう工夫↓
		Replace("^([０-９0-9][０-９0-9][０-９0-9])", "夜夜夜$1", meFindReplaceRegExp | meReplaceAll);
		Replace("^([０-９0-9][０-９0-9])", "　$1", meFindReplaceRegExp | meReplaceAll);
		Replace("^([０-９0-9])", "　　$1", meFindReplaceRegExp | meReplaceAll);
		Replace("夜夜夜", "", meReplaceAll);
		if(t!==""){
			StartOfDocument(false);
			for (i = 0; i < s1.length; i++) {
				D = s1[i];
				T = D.slice(0,1);//一文字目
				if (!((T=="/")||(D==""))){
					Replace(Num2Kan(i),D, meReplaceAll);
					Status="";
				}
			}
		}
		//ここまで↑
		// Kuro. さんの「昇順で並べ替え」と「連続する重複行を削除」を利用させていただいた↓
		SelectAll();
		Text = Text.replace(/\n?$/, "").split("\n").sort().join("\n")+ RegExp.lastMatch;;
		SelectAll();
		var s1 = Text.split("\n");
		var s2	= new Array();
		for (var i = 0; i < s1.length; i++) {
			if (i == 0 || s1[i-1] != s1[i])
  			s2.push(s1[i]);
		}
		Text = s2.join("\n");
			//ここまで↑		
		Replace("^$\n", "", meFindReplaceRegExp | meReplaceAll);//空行削除
	}
    AruLineDel("  約");//約５００°等を削除
    AruLineDel("  表");//表５等を削除
    AruLineDel("  数");
    AruLineDel("  数式");
    AruLineDel("  特開");
    AruLineDel("  (");
    AruLineDel("  （");
	endTime = new Date();
	Status= "処理時間" +(endTime - startTime)/1000 + "秒";
}

function Yoyaku(){//要約書カウント
	with (document.selection) {
  		var s = Text;
  		if (s.length > 0){
  			var Mes="選択文字数: ";
  		} else {// 何も選択してない場合は、【書類名】要約書から所要部分を選択
  			StartOfDocument();
			a = Find ("【書類名】[ 　]*要約書",  meFindNext | meFindReplaceRegExp);
			if (!a) {//要約書の欄がなければ中止
				alert ("要約書の欄がないので作業中止");
				Quit();
			}else{
				var Ty = GetActivePointY(mePosLogical);//("【書類名】[ 　]*要約書"の行を記憶
				Mes="要約書文字数: ";
				a =Find("【書類名】",meFindNext);
				if (!a){//次の【書類名】の欄がなければ最終行へカーソル移動
					StartOfLine();
					document.selection.EndOfDocument( true );
				}else{
					StartOfLine();
					CharLeft();//カーソルを"【書類名】"の手前の改行に
					SetAnchorPoint(mePosLogical, 1, Ty);//選択開始行を"【書類名】[ 　]*要約書"に
				}
  				s = Text;
  			}
  		}
	}
	s = s.replace(/\n/, "");//sの内容から改行マークを取る
	var Ct=count(s)/2;
	Mes = Mes + Ct;
	if (Ct>400 && Mes == "要約書文字数: ") Mes=Mes + " 即ち、"+ (Ct-400)+"文字超過";//要約書400字超えのmessage
   	alert (Mes);
   	document.selection.Collapse(meCollapseEnd);//選択を解除
}

function count(str) {
  len = 0;
  str = escape(str);
  for (i = 0; i < str.length; i++, len++) {
    if (str.charAt(i) == "%") {
      if (str.charAt(++i) == "u") {
        i += 3;
        len++;
      }
      i++;
    }
  }
  return len;
}

function Word(){//WORD文書に変換
	document.selection.SelectAll();
	var S=Editor.ActiveDocument.Selection.Text;
	ClipboardData.SetData(S);
	document.selection.collapse();
	var mydoc = mytxt + "\\MTG.docm";
	var oApplication=new ActiveXObject("Word.Application");
	oApplication.Visible=true; // "Visible" is in the Word Object Model`
	var MD= oApplication.Documents.Open (mydoc);
	oApplication.Run ("PASOadd1");
	MD.Close ();
	mydoc = null;
}

function Fmark(){
	with (document.selection){
		var s = Text;
		if (s.length > 0){
			var Wrd=Text;
		} else {
			StartOfLine(false, mePosLogical);
			EndOfLine(true, mePosLogical);
			var str=Text;
			str = str.replace(/(^[\t 　]+)|([\t 　]+$)/g, "");//前後の空白をトリム
			var Len=str.length;
			var re = new RegExp("[\t 　]+");
			str.match(re);
			var Zen=RegExp.index; 
			var Go=RegExp.lastIndex;
			Wrd=str.substring(Go,Len);
			Wrd=Wrd+str.substring(0,Zen);
		}
		Find(Wrd, meFindNext);
	}
}

//次の関数Num2Kan(n)はネットで得たものです。申し訳ないのですが、ソースがどこからであるか分からなくなってしまいました。ですから、私の創作ではない旨のみここに記しておきます。
function Num2Kan(n){
    var v=String(n);
	txt = new Array("零","一","二","三","四","五","六","七","八","九");
	str = "";
	for (var i=0; i<v.length; i++){
		c = txt[eval(v.charAt(i))];
		str += c;
	}
	str = "竜龍"+str+ "竜龍"; //ここは私が手直ししてあります。
	return (str);
}

function AruLineDel(data){//dataを含む行を削除
	var a = 1;
	do {
		with (Editor.Activedocument.selection){
			a = Find(data, meFindNext|meFindAround);
  			if (a){
  				StartOfLine(false, mePosLogical);
				EndOfLine(true, mePosLogical);
				CharRight(true,1);
				Delete();
			}
		}
  	}while (a > 0);
}

function TextRead(fn){//テキストの内容をreturn
	docB = mytxt + "\\" + fn;
	if(fso.FileExists(docB)){
		var ForReading = 1;           // ﾌｧｲﾙを読み取り専用として開く。
		var TristateUseDefault = -2;  // ｼｽﾃﾑ ﾃﾞﾌｫﾙﾄを使ってﾌｧｲﾙを開く｡
		var fsIn = fso.OpenTextFile(docB, ForReading, false, TristateUseDefault);
		text = fsIn.ReadAll();
		fsIn.Close();
		return text;
	} else {
		return -1;
	}
}

function MLTREP(){
	//Noahさんの複数置換.jsをほぼ丸ごと利用させていただきました。
	startTime = new Date();
	Lnarabe(MRtxt,separator);//MRtxtを開き、第一要素の長い順に並べ、kari.$$$として保存
	// ファイルを開く
	docB = mytxt + "\\kari.$$$";
	var fileObject = fso.OpenTextFile(docB, 1, false, 0);
	// 置換前と置換後のMapを作成（Key：置換前の文字列, Value：置換後の文字列）
	var replaceMap = {};
	// ファイルの読み込み
	while (!fileObject.AtEndOfStream) {
    	var line = fileObject.readLine();
    	index = line.indexOf(separator);
    	if (index > 0) {
        	var before = line.substr(0, index);
        	var after = line.substr(index + separator.length, line.length);
        	if (before.length != 0) {
            	replaceMap[before] = after;
        	}
    	}
	}
	// 読み終わったファイルを閉じる。
	fileObject.Close();
//	Fdel(docB);//kari.$$$を削除
	
	com="選択範囲の";
	// テキストを選択していない場合は全選択
	if (document.selection.Text == "") {
    	document.selection.SelectAll();
    	com="";
	}
	// 選択中のテキストを取得
	var selectionText = document.selection.Text;
	// 置換
	for(before in replaceMap) {
    	var reg = new RegExp(before, 'g');
    	var after = replaceMap[before].replace(/\\n/g, '\n').replace(/\\t/g, '\t');
    	selectionText = selectionText.replace(reg, after);
	}
	// 置換後の文字列を設定
	document.selection.Text = selectionText;
	endTime = new Date();
	Status= com+"一括置換完了しました。処理時間"+(endTime - startTime)/1000 + "秒";
    fileObject = null;
}

//「ポップアップメニューを気軽に扱う」を利用させていただきます
function ShowPopupMenu(menu_obj, position, separator, esc){
    var MAX_NEST = 5;//ネストの最大深度
    
    var id_counter = 1;
    var item_list = [];
    var popup
    var selected_id;
    
    //メニューをESCキーで閉じた時の挙動を登録
    if(esc === undefined){
        item_list[0] = function(){Quit();};
    }
    else{
        item_list[0] = esc;
    }
    
    //メニュー位置の初期化
    if(position !== mePosMouse) {
        position = 0;
    }
    
    //セパレーターを挿入する条件
    var isSeparator = function(str){
        if(separator === false){
            return false;
        }
        else if(typeof separator === "string"){
            return (str.indexOf(separator) !== -1);
        }
        else{
            return (str.indexOf("----") !== -1);
        }
    };
    
    var ObjectOrArray = function(target){
        if(target){
            switch(Object.prototype.toString.call(target) ){
                case "[object Object]":
                    return "Object";
                    break;
                case "[object Array]":
                    return "Array";
                    break;
                default:
                    return "Other";
                    break;
            }
        }
        else{
            return "Other";
        }
    };
    
    var ArrayToPopup = function(list){
        var menu = CreatePopupMenu();
        
        for(var i =0; i < list.length; i++){
            if(isSeparator(list[i].toString() ) ){
                menu.Add("dummy", 999, meMenuSeparator);
            }
            else{
                menu.Add(list[i].toString(), i + 1);
            }
            item_list[i + 1] = list[i];
        }
        return menu;
    };
    
    var  ObjectToPopup = function(obj, nest){
        var menu = CreatePopupMenu();
        
        for(var key in obj){
            if(isSeparator(key) ){
                menu.Add("dummy", 999, meMenuSeparator);
            }
            else{
                if(ObjectOrArray(obj[key] ) !== "Object"){
                    menu.Add(key, id_counter);
                    item_list[id_counter] = obj[key];
                    id_counter++;
                }
                else{
                    if(nest < MAX_NEST){
                        menu.AddPopup(key, ObjectToPopup(obj[key], nest + 1) );
                    }
                }
            }
        }
        return menu;
    };
    //ここまで変数、関数の定義
    //関数の本体はここから
    switch(ObjectOrArray(menu_obj) ){
        case "Object":
            popup =  ObjectToPopup(menu_obj, 0);
            break;
        case "Array":
            popup = ArrayToPopup(menu_obj);
            break;
        default://第1引数が配列かオブジェクト以外の時
            throw new Error("第1引数には配列またはオブジェクトを指定してください");
            break;
    }
    
    selected_id = popup.Track(position);
    
    if(typeof(item_list[selected_id] ) === "function"){
        return item_list[selected_id]();
    }
    else{
        return item_list[selected_id];
    }
}

function Tag(mj){
	var a;
	if (mj=="FONT"){
	    a="<FONT SIZE=6>"
	} else {
		a="<"+mj+">";
	}	
	var b="</"+mj+">";
	var Z = document.selection.Text;
	if (Z.length>0) document.selection.Delete();
	X = a+Z+b;
	ClipboardData.SetData(X);
	document.selection.Paste();
}

function Lnarabe(txt, mm){//一括置換用データを第一要素の長い順に並べる
	docB = OpenFile( mytxt+"\\"+txt, 0, 1 );
	with (docB.selection){
		EndOfDocument( false );
		var E = GetActivePointY(mePosView);
		var F = GetActivePointY(mePosLogical);
		var a = Find (mm, meFindReplaceRegExp|meFindNext|meFindAround);
		if (!a || E!=F ) {//文章中にmmがない若しくは文末の表示行数と論理行数が不一致ならば中止
			if (!a){
				var com="文中に"+mm+"がなく、";
			} else {
				com="表示行数と論理行数が不一致で、";
			} 
			alert (com+"一括置換用辞書データでないようなので作業中止");
			docB.close();
			return -1;
		}
		var mmc="^(?!.*"+mm+").+$";
		Replace(mmc, "", meFindReplaceRegExp | meReplaceAll);//mmのない行削除
		mmc ="^"+mm+".*$"
		Replace(mmc, "", meFindReplaceRegExp | meReplaceAll);//行頭mmの行削除
		Replace("^$\n", "", meFindReplaceRegExp | meReplaceAll);//空行削除
		SelectAll();
		var t=Text;
	}
	var s1 = t.split("\n");
	for (i = 0; i < s1.length; i++) {
		var D= s1[i];
		var T=D.slice(0,1);
		if (!((T=="/")||(D==""))){
			var moto = D.substr(0,D.indexOf(mm));
			docB.selection.SetActivePoint(mePosLogical, 1, i+1);
			var kazu = moto.length;
			if (kazu < 10){
				docB.write(" "+kazu+mm);
			} else {
				docB.write(kazu+mm);
			}
			Status="";
		}
	}
	// Kuro. さんの「降順で並べ替え」と「連続する重複行を削除」を利用させていただいた↓
	with (docB.selection){
		SelectAll();	
		Text = Text.split("\n").sort(function(a, b){ return ((a < b) ? 1 : ((a > b) ? -1 : 0)) }).join("\n") + RegExp.lastMatch;
		SelectAll();
		var s1 = Text.split("\n");
		var s2	= new Array();
		for (var i = 0; i < s1.length; i++) {
			if (i == 0 || s1[i-1] != s1[i])
			s2.push(s1[i]);
		}
		Text = s2.join("\n");
	//ここまで↑		
		Replace("^[ 0-9]*"+mm,"", meFindReplaceRegExp | meReplaceAll);//行頭から最短のmmまで削除
		Status="";
	}
 docB.save(mytxt+"\\kari.$$$");
 docB.Close();
 document.Activate();	// 元のドキュメントに戻る
}

function Rini(){//iniファイルの要素を調べる
	var t = TextRead('MeryTG.ini');
	if (t!==-1){
		var s1 = t.split("\n");
		for (i = 0; i < s1.length; i++) {
			var D= s1[i];
			var Al;
			var T=D.slice(0,1);
			if (!((T=="/")||(D==""))){
				var kazu = D.length - 1;
				var moto = D.substr(0,D.indexOf("="));
				if ((i == s1.length-1) && (D.indexOf("\n") == -1)){//MeryTG.ini最終行がデータ＋EOFの場合
					kazu = kazu -moto.length;
				} else {
					kazu = kazu - moto.length - 1;
				}
				var saki = D.substr(D.indexOf("=")+1,kazu);
				if (Al==""){
					Al=moto+"="+saki;
				} else {
					Al=Al+"="+moto+"="+saki;
				}
				Status="";
			}
		}
		return Al;
	} else {
		return -1;
	}
}

function Parachikan(){//平行置換
	startTime = new Date();
	var yy = document.FullName;
	isOpened(mytxt+"\\"+PRtxt, 1);
	var Fo=Fopen(PRtxt);
	if (Fo==-1){
		return;
	} else {
		document.save("kari.$$$" );//平行置換の辞書ファイルを仮ファイルとして保存
		document.selection.Replace("\t", ",", meFindReplaceRegExp | meReplaceAll);
		LnarabeH(",");
		var E=document.GetLines();
		for (i = 0; i < E; i++) {
			document.selection.SetActivePoint(mePosLogical,1,i+1,false);
			document.write(Num2Kan(i+1)+",");
		}
		xx = new Array();
		for (i = 1; i < E+1; i++) {
			xx[i] = document.getline(i).split(",");
//			alert(xx[i][0]+";"+xx[i][1]+";"+xx[i][2]);
		}
	}
	document.save("kari.$$$" );
	var kariF=document.FullName;//仮ファイルフルネーム
	editor.OpenFile(yy);
	for (i = 1; i < E+1; i++) {
		document.selection.Replace(xx[i][1], xx[i][0], meReplaceAll);
		if ("0123456789０１２３４５６７８９".indexOf(xx[i][1].substr(-1))!=-1){
			document.selection.Replace(xx[i][0]+"([0-9０-９])", xx[i][1]+"$1", meFindNext | meFindReplaceRegExp | meReplaceAll);
		}
		if ("0123456789０１２３４５６７８９".indexOf(xx[i][1].substr(0,1))!=-1){
			document.selection.Replace("([0-9０-９])"+xx[i][0], "$1"+xx[i][1], meFindNext | meFindReplaceRegExp | meReplaceAll);
		}
	}
	for (i = 1; i < E+1; i++) {
		document.selection.Replace(xx[i][0], xx[i][2], meReplaceAll);
	}
	Fdel(kariF);//仮ファイルを削除
	endTime = new Date();
	Status="平行置換完了(結果は未保存)。処理時間" +(endTime - startTime)/1000 + "秒";
}

function Fdel(fn){//ファイルを削除する
//	var fso = new ActiveXObject('Scripting.FileSystemObject');
	//alert(file + "を削除しました");
	fso.DeleteFile(fn);
}

// kazyさんの「Editor.OpenFile()のポリフィル」を使わせていただきます(一部手直しあり)。
function OpenFile(file, encoding, flags){
    var i, j, e, d;
//    file = new ActiveXObject("Scripting.FileSystemObject").GetAbsolutePathName(file);//手直し
    window.Editor.OpenFile(file, encoding, flags);
    var a=-1;//手直し
    for(i = 0; i < window.Editors.Count; i++){
        e = window.Editors.Item(i);
        for(j = 0; j < e.Documents.Count; j++){
            d = e.Documents.Item(j);
            if(d.FullName){
                if((d.FullName).toLowerCase() === (file).toLowerCase()){//手直し
                    return d;
                    a=1;//手直し
                }
            }
        }
    }
    if (a==-1) Alert ("対応するファイルがありません");//手直し
}

function isOpened(filefullname, Cl){//file open中か? Cl==1でそのfileを保存して閉じる。返数は文書NO.
    var result = -1;
    for(i = 0; i < window.Editors.Count; i++){
        e = window.Editors.Item(i);
        for(j = 0; j < e.Documents.Count; j++){
            d = e.Documents.Item(j);
//            alert (i+": "+d.FullName);
			if((d.FullName).toLowerCase()===(filefullname).toLowerCase()){
				if (Cl==1){
					d.save();
					d.Close();
				}
				result=i;
			}
        }
    }
    return result;
}

function Fopen(fn){//ファイルを開く 
	docB = mytxt + "\\" + fn;
	if(fso.FileExists(docB)){
		editor.OpenFile(docB);
		return 1;
	} else {
		alert(fn+'が見当たりません');
		return -1;
	}
}

function LnarabeH(mm){//一括置換用データを第一要素の長い順に並べる
	with (document.selection){
		EndOfDocument( false );
		var E = GetActivePointY(mePosView);
		var F = GetActivePointY(mePosLogical);
		var a = Find (mm, meFindReplaceRegExp|meFindNext|meFindAround);
		if (!a || E!=F ) {//文章中にmmがない若しくは文末の表示行数と論理行数が不一致ならば中止
			if (!a){
				var com="文中に"+mm+"がなく、";
			} else {
				com="表示行数と論理行数が不一致で、";
			} 
			alert (com+"平行置換用辞書データでないようなので作業中止");
			document.close();
			return -1;
		}
		var mmc="^(?!.*"+mm+").+$";
		Replace(mmc, "", meFindReplaceRegExp | meReplaceAll);//mmのない行削除
		mmc ="^"+mm+".*$"
		Replace(mmc, "", meFindReplaceRegExp | meReplaceAll);//行頭mmの行削除
		Replace("^$\n", "", meFindReplaceRegExp | meReplaceAll);//空行削除
		SelectAll();
		var t=Text;
	}
	var s1 = t.split("\n");
	for (i = 0; i < s1.length; i++) {
		var D= s1[i];
		var T=D.slice(0,1);
		if (!((T=="/")||(D==""))){
			var moto = D.substr(0,D.indexOf(mm));
			document.selection.SetActivePoint(mePosLogical, 1, i+1);
			var kazu = moto.length;
			if (kazu < 10){
				document.write(" "+kazu+",");
			} else {
				document.write(kazu+",");
			}
			Status="";
		}
	}
	// Kuro. さんの「降順で並べ替え」と「連続する重複行を削除」を利用させていただいた↓
	with (document.selection){
		SelectAll();	
		Text = Text.split("\n").sort(function(a, b){ return ((a < b) ? 1 : ((a > b) ? -1 : 0)) }).join("\n") + RegExp.lastMatch;
		SelectAll();
		var s1 = Text.split("\n");
		var s2	= new Array();
		for (var i = 0; i < s1.length; i++) {
			if (i == 0 || s1[i-1] != s1[i])
			s2.push(s1[i]);
		}
		Text = s2.join("\n");
	//ここまで↑		
		Replace("^[ 0-9]*,", "", meFindReplaceRegExp | meReplaceAll);//行頭から最短の,まで削除
		document.save();
		StartOfDocument();
		Status="";
	}
}
